program chromy_strelec;
{ Je zadana sachovnice obecne obdelnikovych rozmeru se zakazanymi policky.
  Ukolem je zjistit, zda strelec, ktery stoji na vychozim poli S, se muze
  (pomoci libovolneho poctu tahu) premistit do ciloveho pole C.

  Vstup se cte ze souboru 'strelec.in'
}

const
   max_rozmer = 100;
   vstupni_soubor = 'strelec.in';
   v_cili_zastav = FALSE;

var
   sach: array[0..max_rozmer+1, 0..max_rozmer+1] of integer;
   rozmer_m, rozmer_n: integer;
   Sradek, Ssloupec: integer;
   Cradek, Csloupec: integer;
   krok: integer;


procedure nastav_sachovnici(soubor:string);
{ Nacte vstupni soubor a do globalniho pole sach ulozi konfiguraci sachovnice.

  Struktura vstupu: na prvnim radku dve cela cisla = rozmery m (radku) a n (sloupcu).
  Pak nasleduje m radku, na kazdem cteme n znaku s nasledujicim vyznamem:
  x ... zakazane policko
  . ... volne policko
  S ... startovni pozice strelce
  C ... cilova pozice strelce
}

var
   f: text;
   i,j:integer;
   znak: char;

begin
  assign(f, soubor);
  reset(f);

  readln(f, rozmer_m, rozmer_n);
  for i:= 1 to rozmer_m do begin
    for j:= 1 to rozmer_n do begin
      read(f, znak);
      if znak = '.' then
        sach[i,j]:= -1;
      if (znak = 'x') or (znak = 'X') then
        sach[i,j]:= -2;
      if znak = 'S' then begin
        sach[i,j]:= -1;
        Sradek:= i;
        Ssloupec:= j;
      end;
      if znak = 'C' then begin
        sach[i,j]:= -1;
        Cradek:= i;
        Csloupec:= j;
      end;
    end;
    readln(f);
  end;
  close(f);

  {kolem sachovnice nastavit pas zakazanych poli}
  for i:= 0 to rozmer_m+1 do begin
    sach[i, 0]:= -2;
    sach[i, rozmer_n+1]:= -2;
  end;

  for j:= 0 to rozmer_n+1 do begin
    sach[0, j]:= -2;
    sach[rozmer_m+1, j]:= -2;
  end;
end;


procedure ukaz_sachovnici;

const
  zakaz = 'x';
  mezer = 3;

var
  i,j: integer;

begin
  for i:= 0 to rozmer_m+1 do begin
    for j:= 0 to rozmer_n+1 do
      if (i = Sradek) and (j = Ssloupec) then
        write('S':mezer)
      else if (i = Cradek) and (j = Csloupec) and (sach[i,j] = -1) then
        write('C':mezer)
      else if sach[i,j] = -2 then
        write(zakaz:mezer)
      else if sach[i,j] = -1 then
        write('.':mezer)
      else if sach[i,j] >= 0 then
        write( sach[i,j]:mezer)
      else
        write('?':mezer);
    writeln; {writeln;}
  end;
end;


procedure oznac_krokem(radek, sloupec: integer);
{ Postupne projde vsechna pole, ktera jsou pro chromeho strelce
  dosazitelna.

  Do poli, kam vstoupi, zapisuje poradi, ve kterem byla navstivena.

  Pokud je konstanta v_cili_zastav nastavena na TRUE, pak je cinnost
  ukoncena, jakmile strelec navstivi pole C.
}

begin
  { Tuto cast programu napiste sami. }


end;


begin
  nastav_sachovnici(vstupni_soubor);
  writeln;
  writeln('Sachovnice na vstupu (vcetne pasu zakazanych poli okolo):');
  ukaz_sachovnici;

  krok:= 0;
  oznac_krokem(Sradek, Ssloupec);
  writeln;
  writeln('Sachovnice oznacena poradim, jak jsou pole navstivena:');
  ukaz_sachovnici;
end.


{ Ukazka cinnosti programu:

Sachovnice na vstupu (vcetne pasu zakazanych poli okolo):
  x  x  x  x  x  x  x  x  x  x
  x  .  .  .  .  .  x  .  .  x
  x  .  .  .  .  C  .  .  .  x
  x  .  .  .  x  .  x  .  .  x
  x  .  x  x  x  .  x  .  .  x
  x  .  .  .  .  .  .  .  .  x
  x  .  .  S  .  .  x  .  .  x
  x  .  .  .  .  .  x  .  .  x
  x  .  x  x  x  .  x  x  .  x
  x  .  .  .  .  .  .  .  .  x
  x  x  x  x  x  x  x  x  x  x

Sachovnice oznacena poradim, jak jsou pole navstivena:
  x  x  x  x  x  x  x  x  x  x
  x  . 26  . 24  .  x  . 13  x
  x 27  . 23  . 25  . 12  .  x
  x  . 22  .  x  .  x  . 11  x
  x 21  x  x  x 14  x 10  .  x
  x  . 20  . 15  .  6  .  9  x
  x 19  .  S  .  5  x  7  .  x
  x  . 16  .  1  .  x  .  8  x
  x 17  x  x  x  2  x  x  .  x
  x  . 18  .  4  .  3  .  .  x
  x  x  x  x  x  x  x  x  x  x

}

